<?php
################################################################################
# @Name : upload.php
# @Description : upload attached files 
# @Call : ticket.php
# @Parameters : 
# @Author : Flox
# @Create : 12/08/2013
# @Update : 03/03/2020
# @Version : 3.1.49 p1
################################################################################

//initialize variables 
if(!isset($_FILES['file']['name'])) {$_FILES['file']['name']='';}
$blacklistedfile=0;

//extensions blacklist
$blacklist = array('php', 'php1', 'php2','php3' ,'php4' ,'php5', 'php6', 'php7', 'php8', 'php9', 'php10', 'js', 'htm', 'html', 'phtml', 'exe', 'jsp' ,'pht', 'shtml', 'asa', 'cer', 'asax', 'swf', 'xap', 'phphp', 'inc', 'htaccess', 'sh', 'py', 'pl', 'jsp', 'asp', 'cgi', 'json', 'svn', 'git', 'lock', 'yaml', 'com', 'bat', 'ps1', 'cmd', 'vb', 'hta', 'reg', 'ade', 'adp', 'app', 'asp', 'bas', 'bat', 'cer', 'chm', 'cmd', 'com', 'cpl', 'crt', 'csh', 'der', 'exe', 'fxp', 'gadget', 'hlp', 'hta', 'inf', 'ins', 'isp', 'its', 'js', 'jse', 'ksh', 'lnk', 'mad', 'maf', 'mag', 'mam', 'maq', 'mar', 'mas', 'mat', 'mau', 'mav', 'maw', 'mda', 'mdb', 'mde', 'mdt', 'mdw', 'mdz', 'msc', 'msh', 'msh1', 'msh2', 'mshxml', 'msh1xml', 'msh2xml', 'msi', 'msp', 'mst', 'ops', 'pcd', 'pif', 'plg', 'prf', 'prg', 'pst', 'reg', 'scf', 'scr', 'sct', 'shb', 'shs', 'ps1', 'ps1xml', 'ps2', 'ps2xml', 'psc1', 'psc2', 'tmp', 'url', 'vb', 'vbe', 'vbs', 'vsmacros', 'vsw', 'ws', 'wsc', 'wsf', 'wsh', 'xnk', 'payload', 'shell', 'phar', 'phpt', 'pht', 'pgif');

if($_FILES['file']['name'] && $_GET['id'])
{
	$real_filename=preg_replace("/[^A-Za-z0-9\_\-\.]/", '', $_FILES['file']['name']);
	//extension check
    $ext=explode('.',$real_filename);
	foreach ($ext as &$value) {
		if(in_array(strtolower($value),$blacklist)) {$blacklistedfile=1;} 
	}
    if(!$blacklistedfile) {
		//create upload folder if not exist
		if(!file_exists('./upload/ticket')) {mkdir('./upload/ticket', 0777, true);}
        $target_folder='./upload/ticket/';
		
		//generate storage filename
		$storage_filename=$_GET['id'].'_'.md5(uniqid());
		if(move_uploaded_file($_FILES['file']['tmp_name'], $target_folder.$storage_filename)) 
		{
			//content check
			$file_content = file_get_contents($target_folder.$storage_filename, true);
			if(preg_match('{\<\?php}',$file_content) || preg_match('/system\(/',$file_content)) {
				unlink($target_folder.$storage_filename); //remove file
				echo '<div class="alert alert-danger"><strong><i class="icon-remove"></i> '.T_('Erreur').' : </strong> '.T_('Fichier interdit').'.<br></div>';
			} else {
				$uid=md5(uniqid());
				$qry=$db->prepare("INSERT INTO `tattachments` (`uid`,`ticket_id`,`storage_filename`,`real_filename`) VALUES (:uid,:ticket_id,:storage_filename,:real_filename)");
				$qry->execute(array('uid' => $uid,'ticket_id' => $_GET['id'],'storage_filename' => $storage_filename,'real_filename' => $real_filename));
			} 
		} else {
			echo '<div class="alert alert-danger"><strong><i class="icon-remove"></i> '.T_('Erreur').' : </strong> '.T_('Transfert impossible').'.<br></div>';
		}
    } else {echo '<div class="alert alert-danger"><strong><i class="icon-remove"></i> '.T_('Erreur').' : </strong> '.T_('Fichier interdit').'.<br></div>';}
} 
?>